#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair <ll, ll> pll;

const ll mod = 3;

vector <vector <ll> > d(2, vector <ll>(2)), b(2, vector <ll>(2)), c(2, vector <ll>(2));

vector <vector <ll> > mult(auto a, auto b) {
    vector <vector <ll> > res(2, vector <ll> (2, 0));
    for(ll i = 0; i < 2; i++) {
        for(ll j = 0; j < 2; j++) {
            for(ll z = 0; z < 2; z++) {
                res[i][j] += a[i][z] * b[z][j];
                res[i][j] %= mod;
            }
        }
    }
    return res;
}

ll binpow(ll n) {
    for(ll i = 0; i < 2; i++) {
        for(ll j = 0; j < 2; j++) {
            b[i][j] = d[i][j];
            if(i == j) c[i][j] = 1;
        }
    }
    while(n) {
        if(n%2) {
            c = mult(c, b);
        }
        b = mult(b, b);
        n >>= 1;
    }
    return c[0][1];
}

int main() {
    //ifstream cin("input.txt");
    ios_base:: sync_with_stdio(0);
    ll n;
    cin >> n;
    d[0][0] = 0;
    d[0][1] = d[1][0] = d[1][1] = 1;
    cout << binpow(n);
}
