#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <queue>
#include <sstream>
#include <cctype>

using namespace std;

typedef int ll;
typedef pair <ll, ll> pll;
typedef long double ld;

ll sum(vector<ll>& A)
{
    ll res = 0;
    for (auto& i : A)
        res += i;
    return res;
}

int main()
{
    //ifstream cin("input.txt");
    //ofstream out("output.txt");
    ll n;
    cin >> n;
    ll oddAm = 0, evenAm = 0;
    vector<ll> A(n);
    for (auto& i : A)
    {
        cin >> i;
        if (i % 2 == 0)
            ++evenAm;
        else
            ++oddAm;
    }
    string B;
    cin >> B;
    ll resSum = sum(A);
    for (ll i = 0; i < B.size(); ++i)
    {
        if (B[i] == '0')
        {
            if (evenAm == 0)
            {
                cout << resSum << '\n';
                continue;
            }
            for (ll j = 0; j < n; ++j)
                if (A[j] % 2 == 0)
                {
                    ll save = A[j];
                    A[j] /= 2;
                    if (A[j] % 2 != 0 || (A[j] == 0 && save != 0))
                        --evenAm;
                    if (A[j] % 2 == 1)
                        ++oddAm;
                }
            resSum = sum(A);
        }
        else
        {
            if (oddAm == 0)
            {
                cout << resSum << '\n';
                continue;
            }
            for (ll j = 0; j < n; ++j)
                if (A[j] % 2 == 1)
                {
                    --A[j];
                    --oddAm;
                    if (A[j] != 0)
                        ++evenAm;
                }
            resSum = sum(A);
        }
        cout << resSum << '\n';
    }
}