#include <algorithm>
#include <cctype>
#include <cmath>
#include <cstdlib>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <string>
#include <vector>

#define PI acos(-1)

#define ll long long
#define ld long double

using namespace std;

vector<vector<ll>> g;
vector<bool> used;
vector<int> lp;
queue<int> q;

int main() {
  // ifstream in("longpath.in");
  // ofstream out("longpath.out");
  // freopen("filename", "w", stdout)
  // freopen("filename", "r", stdin)

  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  ll t = 1;
  // cin >> t;
  while (t--) {
    ll n;
    cin >> n;

    vector<pair<ll, ll>> mas(n + 1, {0, 0});
    set<pair<ll, ll>> st;

    ll before = 0;
    for (int j = 0; j < n - 1; j++) {
      ll tmp1, tmp2;
      mas[j + 1].second = j + 1;
      cin >> tmp1 >> tmp2;
      before += ++mas[tmp1].first - 1 + ++mas[tmp2].first - 1;
      st.insert({tmp1, tmp2});
      st.insert({tmp2, tmp1});
    }
    mas[n].second = n;

    sort(mas.begin() + 1, mas.end(), greater<>());

    bool brk = false;

    pair<ll, ll> ff;
    pair<ll, ll> ss;

    ll max = -1;
    for (int j = 1; j <= 2; j++) {
      for (int k = j + 1; k <= n; k++) {
        if (st.count({mas[j].second, mas[k].second}) == 0 &&
            st.count({mas[k].second, mas[j].second}) == 0) {
          if (max < mas[j].first + mas[k].first) {
            max = mas[j].first + mas[k].first;
            ff = mas[j];
            ss = mas[k];
          }
        }
      }
    }
    cout << before + max << endl;
    cout << ff.second << " " << ss.second << endl;
  }
}