#include <algorithm>
#include <cctype>
#include <cmath>
#include <cstdlib>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <string>
#include <vector>

#define PI acos(-1)

#define ll long long
#define ld long double

using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<int> lp;
queue<int> q;

int main() {
  // ifstream in("longpath.in");
  // ofstream out("longpath.out");
  // freopen("filename", "w", stdout)
  // freopen("filename", "r", stdin)

  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  ll t = 1;
  // cin >> t;
  while (t--) {
    ll n;
    cin >> n;
    string str;
    cin >> str;
    map<char, char> mp;
    mp['A'] = 'T';
    mp['T'] = 'A';
    mp['C'] = 'G';
    mp['G'] = 'C';
    bool nice = true;

    if (n == 1) {
      cout << "NO" << endl;
      return 0;
    }

    for (int j = 0; j <= n / 2; j++) {
      if (str[n - j - 1] != mp[str[j]]) {
        nice = false;
        break;
      }
    }

    if (nice)
      cout << "YES" << endl;
    else
      cout << "NO" << endl;
  }
}