#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	ll sum = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum += a[i];
	}
	string s;
	cin >> s;
	
	int k = s.size();
	s = ' ' + s;
	vector<int> ind0(k + 1);
	vector<int> ind1(k + 1);
	int prev0 = k + 1;
	int prev1 = k + 1;
	for (int i = k; i >= 1; --i) {
		if (s[i] == '0')
			prev0 = i;
		if (s[i] == '1')
			prev1 = i;
		
		ind0[i] = prev0;
		ind1[i] = prev1;
	}
	/*
	for (int e : ind0)
		cout << e << " ";
	cout << endl;
	for (int e : ind1)
		cout << e << " ";
	cout << endl;
	*/
	vector<ll> d(k + 1, 0);
	for (int i = 0; i < n; ++i) {
		ll num = a[i];
		int pos = 1;
		for (; num > 0 && pos <= k;) {
			if (num & 1) {
				pos = ind1[pos];
				if (pos == k + 1)
					break;
				--d[pos];
				--num;
				++pos;
			}
			else {
				pos = ind0[pos];
				if (pos == k + 1)
					break;
				d[pos] -= num / 2;
				num /= 2;
				++pos;
			}
		}
	}
	
	ll ans = sum;
	for (int i = 1; i <= k; ++i) {
		sum += d[i];
		cout << sum << "\n";
	}
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}