#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

ll query(ll x) {
	cout << "run " << x << endl;
	int ans;
	cin >> ans;
	return ans;
}

map<ll, ll> ansmap;

int check(ll x, ll &sum) {
	ll cnt = sum / x;
	ll kd = (cnt + 1) * x;
	ll q = kd - sum - 1;
	
	ll ans1;
	if (q == 0)
		ans1 = ansmap[sum];
	else {
		ans1 = query(q);
		sum += q;
		ansmap[sum] = ans1;
	}
	if (ans1 > cnt) {
		return 1;
	}
	
	ll ans2 = query(1);
	sum += 1;
	ansmap[sum] = ans2;
	if (ans2 <= cnt) {
		return 2;
	}
	
	return 0;
}

void solve() {
	ll sum = 0;
	
	ll l = 1, r = 100;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		
		int res = check(m, sum);
		
		if (res == 1)
			r = m;
		else if (res == 2)
			l = m;
		else {
			cout << "ensure " << m << endl;
			return;
		}
	}
	
	int resl = check(l, sum);
	cout << "ensure " << (resl == 0 ? l : r) << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}