#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	map<int, set<int>> pos;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		pos[a[i]].insert(i);
	}
	
	ll ans = 0;
	int cnt = 0, cur = -1;
	for (; !pos.empty();) {
		auto &p = *(--pos.end());
		int num = p.first;
		auto &numpos = p.second;
		
		auto next = numpos.upper_bound(cur);
		if (next == numpos.end()) {
			++cnt;
			ans += cnt;
			cur = *numpos.begin();
			numpos.erase(numpos.begin());
			if (numpos.empty())
				pos.erase(--pos.end());
		}
		else {
			ans += cnt;
			cur = *next;
			numpos.erase(next);
			if (numpos.empty())
				pos.erase(--pos.end());
		}
	}
	
	cout << ans << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}