#include <iostream>
#include <fstream>
#include <string>
using namespace std;
void sortc(long long* m, int n)
{
	int tmp, k;
	int s = n; // готовим начальный шаг
	long long cnt = 0;
	while (n > 1) {
		s /= 1.247f; // шаг на этом проходе.  На первом проходе получается примерно 80% от размера массива,
										// и легкие элементы в хвосте переносятся в первые 20% 
		if (s < 1) s = 1; // 0 быть не может, присвоим 1
		k = 0; // нет перестановок
		for (int i = 0; i + s < n; ++i) { // двигаемся, пока сравниваемый элемент (на s от текущего) в массиве
			if (m[i] < m[i + s]) {
				tmp = m[i];
				m[i] = m[i + s];
				m[i + s] = tmp;
				k = i;
			}
			++cnt;
		}
		if (s == 1) // шаг 1, как в обычном пузырьке. Включаем контроль	
			n = k + 1;
	}
}
int main() {
	int n;
	long long a[100000];
	string c;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cin >> c;
	sortc(a, n);
	if (n - 1 > 0) {
		while (a[n - 1] == 0)
		{
			n--;
			if (n == 1) break;
		}
	}
	long long sum = 0;
	for (int i = 0; i < c.size(); i++) {

		if (c[i] == '0') {
			for (int j = 0; j < n; j++) {
				if (a[j] % 2 == 0) {
					a[j] /= 2;
				}
				sum += a[j];
			}
		}
		else {
			for (int j = 0; j < n; j++) {
				if (a[j] % 2 == 1) {
					a[j] -= 1;
				}
				sum += a[j];
			}
			sortc(a, n);
			if (n - 1 != 0) {
				while (a[n - 1] == 0)
				{
					n--;
					if (n == 1) break;
				}
			}
		}


		cout << sum << endl;
		sum = 0;
	}
	return 0;
}
