#include <iostream>
#include <fstream>
#include <string>
using namespace std;
void sortc(unsigned int* m, int n)
{
	int tmp, k;
	int s = n; // готовим начальный шаг
	unsigned int cnt = 0;
	while (n > 1) {
		s /= 1.247f; // шаг на этом проходе.  На первом проходе получается примерно 80% от размера массива,
										// и легкие элементы в хвосте переносятся в первые 20% 
		if (s < 1) s = 1; // 0 быть не может, присвоим 1
		k = 0; // нет перестановок
		for (int i = 0; i + s < n; ++i) { // двигаемся, пока сравниваемый элемент (на s от текущего) в массиве
			if (m[i] < m[i + s]) {
				tmp = m[i];
				m[i] = m[i + s];
				m[i + s] = tmp;
				k = i;
			}
			++cnt;
		}
		if (s == 1) 
			n = k + 1;
	}
}
int main() {
	int n;
	unsigned int a[100000], b[100000], vvod, raz_b = 0, raz_a = 0;
	string c;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> vvod;
		if (vvod % 2 == 0) { b[raz_b] = vvod; raz_b++; }
		else { a[raz_a] = vvod; raz_a++; }
	}
	cin >> c;
	sortc(a, raz_a);
	sortc(b, raz_b);
	if ((raz_b - 1) != 0) {
		while (b[raz_b - 1] == 0)
		{
			raz_b--;
			if (raz_b == 1) break;
		}
	}
	unsigned int sum = 0;
	int seiv = 0;
	for (int i = 0; i < c.size(); i++) {

		if (c[i] == '0') {
			seiv = 0;
			for (int j = 0; j < raz_b; j++) {
				b[j] /= 2;
				if (b[j] % 2 == 0) {
					b[seiv] = b[j];
					sum += b[seiv];
					seiv++;
				}
				else { a[raz_a] = b[j]; raz_a++; }
			}
			raz_b = seiv;
			for (int j = 0; j < raz_a; j++) sum += a[j];
		}
		else {
			seiv = 0;
			for (int j = 0; j < raz_a; j++) {
				a[j] -= 1;
				if (a[j] % 2 == 1) {
					a[seiv] = a[j];
					sum += a[seiv];
					seiv++;
				}
				else { b[raz_b] = a[j]; raz_b++; }
			}
			raz_a = seiv;
			for (int j = 0; j < raz_b; j++) sum += b[j];
			sortc(b, raz_b);
			if ((raz_b - 1) != 0) {
				while (b[raz_b - 1] == 0)
				{
					raz_b--;
					if (raz_b == 1) break;
				}
			}
		}


		cout << sum << endl;
		sum = 0;
	}
	return 0;
}
