#include <iostream>
#include <fstream>
#include <string>
using namespace std;
void sortc(int* m, int n)
{
	int tmp, k;
	int s = n; // готовим начальный шаг
	long long cnt = 0;
	while (n > 1) {
		s /= 1.247f; // шаг на этом проходе.  На первом проходе получается примерно 80% от размера массива,
		if (s < 1) s = 1; // 0 быть не может, присвоим 1
		k = 0; // нет перестановок
		for (int i = 0; i + s < n; ++i) { // двигаемся, пока сравниваемый элемент (на s от текущего) в массиве
			if (m[i] < m[i + s]) {
				tmp = m[i];
				m[i] = m[i + s];
				m[i + s] = tmp;
				k = i;
			}
			++cnt;
		}
		if (s == 1) // шаг 1, как в обычном пузырьке. Включаем контроль	
			n = k + 1;
	}
}
int main() {
	int n;
	int a[100000];
	int sh;
	int sa;
	int count = 0;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		
	}
	cin >> sh >> sa;
	for (int i = 0; i < n; i++) {
		a[i] = abs(sa - a[i]);
	}
	sortc(a, n);
	int lenSh = abs(sa - sh);
	for (int i = n-1; i >= 0; i--) {
		if (lenSh > a[i]) {
			count++;
			lenSh--;
		}
	}
	cout << count<<endl;
	return 0;
}