#include <iostream>
using namespace std;

inline void  fib_mult(unsigned long long int* f, unsigned long long int* g)
{
    long int tmp = f[0] * g[0] + f[1] * g[1];
    f[1] = f[0] * g[1] + f[1] * (g[0] + g[1]);
    f[0] = tmp;
}

int Fibonacci(unsigned long long int n)
{
    unsigned long long int f[] = { 1, 0 };
    unsigned long long int g[] = { 0, 1 };
    while (n > 0)
    {
        if (n & 1)
        {
            fib_mult(f, g);
            --n;
        }
        else
        {
            fib_mult(g, g);
            n >>= 1;
        }
    }
    return f[1];
}

int main()
{
    unsigned long long int n;
    cin >> n;
    cout << Fibonacci(n) % 3;
    return 0;
}