#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;

vector<ll> getArray(vector<vector<ll>> vec, int n, int glub) {
    vector<ll> newV;
    for (int i = glub; i < n - glub; i++) {
        newV.push_back(vec[glub][i]);
    }
    for (int i = glub + 1; i < n - glub; i++) {
        newV.push_back(vec[i][n - glub - 1]);
    }

    vector<ll> newV2;
    for (int i = glub; i < n - glub - 1; i++) {
        newV2.push_back(vec[n - glub - 1][i]);
    }
    reverse(newV2.begin(), newV2.end());

    for (int i = 0; i < newV2.size(); i++) {
        newV.push_back(newV2[i]);
    }

    vector<ll> newV3;
    for (int i = glub + 1; i < n - glub - 1; i++) {
        newV3.push_back(vec[i][glub]);
    }
    reverse(newV3.begin(), newV3.end());

    for (int i = 0; i < newV3.size(); i++) {
        newV.push_back(newV3[i]);
    }

    return newV;
}

vector<ll> getRoll(vector<ll> vec, int n, int position) {
    vector<ll> newV;
    for (int i = position; i < n; i++) {
        newV.push_back(vec[i]);
    }
    for (int i = 0; i < position; i++) {
        newV.push_back(vec[i]);
    }

    return newV;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<ll> chet(n, 0);
    vector<ll> nechet(n, 0);

    int iChet = 0;
    int iNeChet = 0;

    ll ans = 0;

    for (int i = 0; i < n; i++) {
        ll a;
        cin >> a;
        if (a % 2 == 0) {
            chet[iChet++] = a;
        } else {
            nechet[iNeChet++] = a;
        }
        ans += a;
    }
    string s;
    cin >> s;
    for (int i = 0; i < s.length(); i++) {
        if (s[i] == '1') {
            for (int j = 0; j < iNeChet; j++) {
                if (nechet[j] - 1 != 0) {
                    chet[iChet++] = nechet[j] - 1;
                }
                ans--;
            }
            iNeChet = 0;
        } else {
            for(int j = 0; j < iChet; j++){
                ll k = chet[j];
                ans -= (k - k/2);
                k -= k/2;
                if(k % 2 != 0){
                    swap(chet[iChet-1], chet[j]);
                    iChet--;
                    j--;
                    nechet[iNeChet++] = k;
                } else {
                    chet[j] = k;
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}