#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;

vector<ll> check(vector<vector<ll>> vec, int n, int position, int glub) {
    vector<ll> newV;
    if (position == 0) {
        for (int i = 0 + glub; i < n - glub; i++) {
            newV.push_back(vec[glub][i]);
        }
    } else if (position == 1) {
        for (int i = 0 + glub; i < n - glub; i++) {
            newV.push_back(vec[i][n - glub - 1]);
        }
    } else if (position == 2) {
        for (int i = 0 + glub; i < n - glub; i++) {
            newV.push_back(vec[n - glub - 1][i]);
        }
        reverse(newV.begin(), newV.end());
    } else if (position == 3) {
        for (int i = 0 + glub; i < n - glub; i++) {
            newV.push_back(vec[i][glub]);
        }
        reverse(newV.begin(), newV.end());
    }

    return newV;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll>> first(n, vector<ll>(n, 0));
    vector<vector<ll>> second(n, vector<ll>(n, 0));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll a;
            cin >> a;
            first[i][j] = a;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll a;
            cin >> a;
            second[i][j] = a;
        }
    }


    for (int i = 0; i < n / 2; i++) {
        bool flag = false;
        for (int j = 0; j < 4; j++) {
            if (check(first, n, 0, i) == check(second, n, j, i)) {
                flag = true;
                bool flag2 = true;
                for (int kk = 0; kk < 4; kk++) {
                    if (check(first, n, kk, i) != check(second, n, (j + kk) % 4, i)) {
                        flag2 = false;
                        break;
                    }
                }
                if (!flag2) {
                    cout << "NO";
                    return 0;
                }
            }
        }
        if (!flag) {
            cout << "NO";
            return 0;
        }
    }

    cout << "YES";


    return 0;
}