#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;

vector<ll> getArray(vector<vector<ll>> vec, int n, int glub) {
    vector<ll> newV;
    for (int i = glub; i < n - glub; i++) {
        newV.push_back(vec[glub][i]);
    }
    for (int i = glub+1; i < n - glub; i++) {
        newV.push_back(vec[i][n - glub - 1]);
    }

    vector<ll> newV2;
    for (int i = glub; i < n - glub-1; i++) {
        newV2.push_back(vec[n - glub - 1][i]);
    }
    reverse(newV2.begin(), newV2.end());

    for(int i = 0; i < newV2.size(); i++){
        newV.push_back(newV2[i]);
    }

    vector<ll> newV3;
    for (int i = glub+1; i < n - glub-1; i++) {
        newV3.push_back(vec[i][glub]);
    }
    reverse(newV3.begin(), newV3.end());

    for(int i = 0; i < newV3.size(); i++){
        newV.push_back(newV3[i]);
    }

    return newV;
}

vector<ll> getRoll(vector<ll> vec, int n, int position){
    vector<ll> newV;
    for(int i = position; i < n; i++){
        newV.push_back(vec[i]);
    }
    for(int i = 0; i < position; i++){
        newV.push_back(vec[i]);
    }

    return newV;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll>> first(n, vector<ll>(n, 0));
    vector<vector<ll>> second(n, vector<ll>(n, 0));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll a;
            cin >> a;
            first[i][j] = a;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll a;
            cin >> a;
            second[i][j] = a;
        }
    }


    for (int i = 0; i < n / 2; i++) {
        bool flag = false;
        vector<ll> f1 = getArray(first, n, i);
        vector<ll> f2 = getArray(second, n, i);

        for(int j = 0; j <= f2.size(); j++){
            if(f1 == getRoll(f2, f2.size(), j)) {
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << "NO";
            return 0;
        }
    }

    cout << "YES";


    return 0;
}