#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;


void runn(ll time) {
    cout << "run " << time << endl;
    fflush(stdout);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll count = 0;
    ll run = 0;
    ll max = 1e9;
    ll min = 0;

    runn(max);

    run += max;
    cin >> count;
    min = run / (count + 1) + 1;
    max = run / count;

    while (min < max - 1) {
        ll avr = (max - min) / 2;
        avr += min;
        runn(avr);
        run += avr;

        //считываем круги
        ll a = run / 1000;
        //cin >> a;

        //считаем новые диапазоны
        if (count > a){
            max = avr;
        } else {
            min = avr;
        }

        count = a;
    }

    ll backCount = count;
    if (run - (min * (count)) == 0) {
        cout << "ensure " << min << endl;
    } else {
        runn((min * (count+1)) - run);

        cin >> count;

        if (count == backCount) {
            cout << "ensure " << max << endl;
        } else {
            cout << "ensure " << min << endl;
        }
    }
    return 0;
}