#include <fstream>
#include <iostream>
#include <cmath>

using namespace std;

unsigned long long int k, j;

ifstream in("input.txt");
ofstream out("output.txt");

unsigned long int fib(unsigned long long int n)
{
	if (n == 0) return 0;
	if (n == 1) return 1;
	unsigned long long int x1 = 0;
	unsigned long long int x2 = 1;
	unsigned long long int x = 0;
	for (unsigned long long int i = 2; i<=n; i++)
	{
		x = x1 + x2;
		x1 = x2;
		x2 = x;
	}
	return x;
}

int main()
{
    in >> k;
	j = fib(k);
    out << j%3;
    return 0;
}
