#include <fstream>
#include <iostream>
#include <cmath>

using namespace std;

unsigned long int n;

ifstream in("input.txt");
ofstream out("output.txt");

int64_t fib(int64_t n)
{
	if (n == 0) return 0;
	if (n == 1) return 1;
	int64_t x1 = 0;
	int64_t x2 = 1;
	int64_t x = 0;
	for (int64_t i = 2; i<=n; i++)
	{
		x = x1 + x2;
		x1 = x2;
		x2 = x;
	}
	return x;
}

int main()
{
    in >> n;
	int a[8] = {0,1,1,2,0,2,2,1};
	out << a[n%8];
    return 0;
}

