#include<bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
const char *yes = "YES", *no = "NO";

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    T el;
    if(v.size() == 0) {
        while(in >> el) {
            v.push_back(el);
        }
    } else {
        for(auto& x : v) {
            in >> x;
        }
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> v) {
    for(const auto& x : v) out << x << ' ';
    return out;
}

int mod(const int& num, const int& module) {
    return ((num % module) + module) % module;
}

inline void solve() {
    
    int n; cin >> n;
    map<ll, int> mp;    
    for(int i = 0; i < n; ++i) {
        ll c; cin >> c;
        mp[c]++;
    }
    string s; cin >> s;
    
    ll sum_odd = 0, sum_even = 0;
    for(const auto& [k, v] : mp) {
        if(k&1) {
            sum_odd += k*v;
        } else {
            sum_even += k*v;
        }
    }
    for(const auto& x : s) {
        if(x == '0') {
            for(auto& [k, v] : mp) {
                if(k%2 == 0) {
                    int id = k/2;
                    mp[id] += v;
                    sum_even -= k*v;
                    if(id&1) {
                        sum_odd += id*v;
                    } else {
                        sum_even += id*v;
                    }
                    mp[k] = 0;
                }
            }
        } else {
            for(auto& [k, v] : mp) {
                if(k&1) {
                    int id = k-1;
                    mp[id] += v;
                    sum_odd -= k*v;
                    sum_even += id*v;
                    mp[k] = 0;
                }
            }
        }
        cout << sum_even + sum_odd << '\n';
    }
    
    /*ll n; cin >> n;
    vector<ll> x(n); cin >> x;
    ll y; cin >> y;
    ll z; cin >> z;
    
    sort(all(x));
    ll ans = 0;
    if(z < y) {
        for(ll i = 0; i < n && x[i] < y; ++i) {
            ans += ((x[i] + 1 != y) && (abs(z) != (abs(y)+abs(x[i]))/2));
        }
    } else {
        ll i = 0;
        while(i < n && x[i] <= y) {
            i++;
        }
        for(; i < n; i++) {
            ans += ((x[i] - 1 != y) && (abs(z) != (abs(y)+abs(x[i]))/2));
        }
    }
    cout << ans;*/
    /*string s, t; cin >> s >> t;
    if(s.size() < t.size()) {
        s += string(t.size() - s.size(), '-');
    } else if(t.size() < s.size()) {
        t += string(s.size() - t.size(), '-');
    }    
    s = '-' + s, t = '-' + t;
    assert(s.size() == t.size());
    vector<int> a(s.size(), 0);
    for(int i = 0; i < s.size(); ++i) {
        if(s[i] == t[i] && s[i] != '-') {
            a[i] = a[i-1] + 1;
        } else {
            a[i] = 0;
        }
    }
    int mx = *max_element(all(a));
    cout << (mx == 0 ? -1 : mx);*/
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1; //cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}
