#include<bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
const char *yes = "YES", *no = "NO";

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    T el;
    if(v.size() == 0) {
        while(in >> el) {
            v.push_back(el);
        }
    } else {
        for(auto& x : v) {
            in >> x;
        }
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> v) {
    for(const auto& x : v) out << x << ' ';
    return out;
}

int mod(const int& num, const int& module) {
    return ((num % module) + module) % module;
}

inline void solve() {
    
    int n; cin >> n;
    vector<int> x(n); cin >> x;
    int y; cin >> y;
    int z; cin >> z;
    
    sort(all(x));
    int ans = 0;
    if(z < y) {
        for(int i = 0; i < n && x[i] < y; ++i) {
            ans += (x[i] + 1 != y);
        }
    } else {
        int i = 0;
        while(i < n && x[i] <= y) {
            i++;
        }
        for(; i < n; i++) {
            ans += (x[i] - 1 != y);
        }
    }
    cout << ans;
    /*string s, t; cin >> s >> t;
    if(s.size() < t.size()) {
        s += string(t.size() - s.size(), '-');
    } else if(t.size() < s.size()) {
        t += string(s.size() - t.size(), '-');
    }    
    s = '-' + s, t = '-' + t;
    assert(s.size() == t.size());
    vector<int> a(s.size(), 0);
    for(int i = 0; i < s.size(); ++i) {
        if(s[i] == t[i] && s[i] != '-') {
            a[i] = a[i-1] + 1;
        } else {
            a[i] = 0;
        }
    }
    int mx = *max_element(all(a));
    cout << (mx == 0 ? -1 : mx);*/
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1; //cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}
