import java.util.Scanner;
public class ICPC2020F {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        System.out.println(getFibonacciLastDigit(n));
    }

    private static int getFibonacciLastDigit(int n) {
        if (n <= 1) {
            return n;
        }
        int first = 0;
        int second = 1;

        for (int i = 1; i < n; i++) {
            int temp = (first + second) % 3;
            first = second;
            second = temp;
        }
        return second;
    }
}