#include <iostream>
#include <string>
#include <vector>

using namespace std;

typedef long long intl;

void use0(vector<int> &kr)
{
    for ( int i = 0; i < kr.size(); ++i)
    {
        if (kr[i] % 2 == 0)
            kr[i] /= 2;
    }
}

void use1(vector<int> &kr)
{
    for ( int i = 0; i < kr.size(); ++i)
    {
        if (kr[i] % 2 != 0)
            kr[i]--;
    }
}

void usez(vector<int> &kr, char z)
{
    switch (z) {
        case '0':
            use0(kr);
            break; 
        case '1':
            use1(kr);
            break;
    }
}

int suma(vector<int> &kr)
{
    int sum = 0;
    for (auto i : kr)
        sum += i;
    return sum;
}

int main ( void )
{
    int n;
    cin >> n;

    vector<int> kr(n);
    for ( int i = 0; i < n; ++i)
        cin >> kr[i];
    
    string zk;
    cin >> zk;
    
    char *p = (char*)zk.c_str();
    while (*p != '\0')
    {
        intl sum = 0;
        usez(kr, *p);
        sum = suma(kr);

        printf("%lli\n", sum);
        p++;
    }
}