#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <climits>
#include <utility>

typedef long long int lli;
typedef unsigned long long int ull;
typedef long double ld;
using namespace std;

bool cmp(vector <ull> a, vector <ull> b)
{
	return a.size() > b.size();
}

bool connect(vector <vector <ull>>& arr, ull l, ull r)
{
	//cout << l << " " << r << " searchin for: " << arr[l][0] << endl;
	auto s = find(arr[r].begin(), arr[r].end(), arr[l][0]);
	if (s != arr[r].end()) return false;
	else return true;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	ull n;
	cin >> n;

	vector <vector <ull>> arr(n, vector <ull>(0));
	for (ull i = 0; i < n; i++)
		arr[i].push_back(i + 1);

	for (ull i = 0; i < n-1; i++)
	{
		ull ta, tb;
		cin >> ta >> tb;
		arr[ta - 1].push_back(tb);
		arr[tb - 1].push_back(ta);
	}

	sort(arr.begin(), arr.end(), cmp);

	ull l = 0, r = 1;
	bool tr = false;
	while (!tr)
	{
		//cout << "try: " << l << " " << r << endl;
		tr = connect(arr, l, r);
		if (!tr)
		{
			if (r + 1 < n)
			{
				if (arr[r + 1].size() * arr[l].size() < arr[l + 1].size() * arr[r].size() && l + 1 < r)
					l++;
				else
					r++;
			}
			else l++;
		}
	}
	arr[l].push_back(r + 1);
	arr[r].push_back(l + 1);

	ull sum = 0;
	for (ull i = 0; i < arr.size(); i++)
	{
		ull tmp = arr[i].size() - 1;
		sum += (tmp * tmp - tmp) / 2;
	}
	
	cout << sum << endl << arr[l][0] << " " << arr[r][0];

	//[1, 2, 3, 4], [4, 1, 5, 6], [2, 1], [3, 1], [5, 4], [6, 4]
}