def prime_factors(n):
    res = []
    d = 2
    while d * d <= n:
        if n % d == 0:
            res.append(d)
            n //= d
        else:
            d += 1
    if n > 1:
        res.append(n)
    return res


n = int(input())
factors = prime_factors(n)

res = []
for factor in factors:
    if factor > 10:
        res.append(factor)

if len(res) == 1:
    print(res[0])
else:
    print("ERROR")
