#include <iostream>
#include <cmath>

using namespace std;

long unsigned fib(long unsigned n)
{
    if (n == 0)
    {
        return 0;
    }
    if (n <= 2)
    {
        return 1;
    }
    long unsigned a = 1;
    long unsigned b = 1;
    long unsigned ans = 0;
    for (long unsigned i = 3; i <= n; i++)
    {
        ans = a + b;
        a = b;
        b = ans;
    }
    return ans;
}

int main()
{
    long unsigned n;
    cin >> n;
    if (n == 0)
        cout << 0;
    else
        cout << fib(n) % 3;
    return 0;
}