#include <bits/stdc++.h>
 
#define PI acos(-1.0)
#define vvi vector<vector<int>>
#define vi vector<int>
#define ll long long
#define vvl vector<vector<ll>>
#define vl vector<ll>
#define pri pair<int, int>
#define prl pair<ll, ll>
#define ff first
#define vb vector<bool>
#define ss second
#define TEST 0
 
using namespace std;

inline vvl MatrixMul(vvl a, vvl b) {
	vvl ans(a.size(), vl(b[0].size()));

	for (int i = 0; i < a.size(); i++) {
		for (int j = 0; j < b[0].size(); j++) {
			ans[i][j] = 0;

			for (int k = 0; k < a[0].size(); k++) {
				ans[i][j] += a[i][k] * b[k][j];
			}
		}
	}

	return ans;
}

inline vvl BinPow(vvl a, ll n) {
	vvl ans = {{1, 0},{0, 1}};

	while (n) {
		if (n & 1) {
			ans = MatrixMul(ans, a);
		}
		
		a = MatrixMul(a, a);
		n >>= 1;
	}

	return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
 
    #if TEST
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

	ll n;

	cin >> n;
	

	vvl a = {{0, 1}, {1, 1}}, t = {{0, 1}};


	a = BinPow(a, n);
	a = MatrixMul(t, a);

	cout << a[0][0] % 3; 

    return 0;
}