#include <algorithm>
#include <cctype>
#include <cmath>
#include <cstdlib>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <string>
#include <vector>

#define PI acos(-1)

#define ld unsigned long double
#define ll long long
using namespace std;

vector<vector<ll>> g;
vector<bool> used;
vector<int> lp;
queue<int> q;

int main() {
  // ifstream in("longpath.in");
  // ofstream out("longpath.out");
  // freopen("filename", "w", stdout)
  // freopen("filename", "r", stdin)

  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  ll t = 1;
  // cin >> t;
  while (t--) {
    ll n;
    cin >> n;

    g.resize(n + 1, vector<ll>());
    vector<pair<ll, ll>> mas(n + 1, {0, 0});
    set<pair<ll, ll>> st;

    for (int j = 0; j < n - 1; j++) {
      ll tmp1, tmp2;
      mas[j + 1].second = j + 1;
      cin >> tmp1 >> tmp2;
      g[tmp1].push_back(tmp2);
      g[tmp2].push_back(tmp1);
      mas[tmp1].first++;
      mas[tmp2].first++;
      st.insert({tmp1, tmp2});
      st.insert({tmp2, tmp1});
    }
    mas[n].second = n;
    ll before = 0;

    sort(mas.begin() + 1, mas.end(), greater<>());
    for (int j = 1; j <= n; j++) {
      before += ((ll)g[j].size() * ((ll)g[j].size() - 1)) / 2;
    }
    bool brk = false;

    pair<ll, ll> ff;
    pair<ll, ll> ss;
    for (int j = 1; j <= n; j++) {
      for (int k = j + 1; k <= n; k++) {
        if (st.count({mas[j].second, mas[k].second}) == 0 &&
            st.count({mas[k].second, mas[j].second}) == 0) {
          ff = mas[j];
          ss = mas[k];
          brk = true;
          break;
        }
      }
      if (brk) break;
    }

    cout << before + ff.first + ss.first << endl;
    cout << ff.second << " " << ss.second << endl;
  }
}