// Задание: F. Раздача Фибоначчи
// Контест: Yandex - The 2020 East Siberian Regional Contest
// URL: https://official.contest.yandex.ru/contest/20851/problems/F/
// Ограничение памяти: 256 MB
// Ограничение времени: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)

//░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
//░░░░░                      ░░░░░
//░░░░░ Copyright  TheAct1on ░░░░░
//░░░░░                      ░░░░░
//░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
//░░░░░▄▀▀▀▄░░░▄▀▀▀▀▄░░░▄▀▀▀▄░░░░░
//▄███▀░◐░░░▌░▐0░░░░0▌░▐░░░◐░▀███▄
//░░░░▌░░░░░▐░▌░▐▀▀▌░▐░▌░░░░░▐░░░░
//░░░░▐░░░░░▐░▌░▌▒▒▐░▐░▌░░░░░▌░░░░

#include <algorithm>
#include <cctype>
#include <cmath>
#include <cstdlib>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <string>
#include <vector>

#define PI acos(-1)

#define ll long long
#define ld long double

#define MOD 1000003LL

long long my_mod(long long a, long long mod) { return (a % mod + mod) % mod; }

long long add_mod(long long a, long long b, long long mod) {
  return my_mod((my_mod(a, mod) + my_mod(b, mod)), mod);
}

using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<int> lp;
queue<int> q;

int main() {
  // ifstream in("longpath.in");
  // ofstream out("longpath.out");
  // freopen("filename", "w", stdout)
  // freopen("filename", "r", stdin)

  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  ll t = 1;
  // cin >> t;
  while (t--) {
    ll n;
    cin >> n;
    vector<ll> mas(8);
    mas[0] = 0;
    mas[1] = 1;
    for (int j = 2; j < 8; j++) {
      mas[j] = add_mod(mas[j - 1], mas[j - 2], 3);
    }

    cout << mas[n % 8] << endl;
  }
}