#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <sstream>
#include <iomanip>
#include <set>
#include <fstream>
#include <map>
#include <stack>
#include <string>
#include <cstring>
#include <cmath>
#include <cstdio>
#define ll long long
#define ld long double
#define INF 1000000000
using namespace std;
vector<int> zfunct(string &s){
    vector<int> z(s.size());
    z[0]=0;
    int l=-1,r=-1;
    for (int i=1;i<s.size();++i){
        z[i]=0;
        if (i<=r){
            z[i]=min(r-i+1,z[i-l]);
        }
        while (i+z[i]<s.size() && s[z[i]]==s[z[i]+i]){
            ++z[i];
        }
        if (i+z[i]-1>r){
            r = i + z[i] - 1;
            l = i;
        }
    }
    z[0]=z.size();
    return z;
}
void solved(){
    ll n;
    cin >> n;
    vector<vector<ll>> a(n,vector<ll>(n)),b(n,vector<ll>(n));
    for (int i=0;i<n;i++){
        for (int j=0;j<n;j++){
            cin >> a[i][j];
        }
    }
    for (int i=0;i<n;i++){
        for (int j=0;j<n;j++){
            cin >> b[i][j];
        }
    }
    bool flag;
    for (int num=2;num<=n;num+=2){
        string s,help;
        for (ll i=n/2-num/2;i<n/2+num/2;i++){
            s+=a[n/2-num/2][i]+'0';
        }
        for (ll i=n/2-num/2+1;i<n/2+num/2;i++){
            s+=a[i][n/2+num/2-1]+'0';
        }
        for (ll i=n/2+num/2-2;i>=n/2-num/2;i--){
            s+=a[n/2+num/2-1][i]+'0';
        }
        for (ll i=n/2+num/2-2;i>n/2-num/2;i--){
            s+=a[i][n/2-num/2]+'0';
        }
        s+='#';
        for (ll i=n/2-num/2;i<n/2+num/2;i++){
            help+=b[n/2-num/2][i]+'0';
        }
        for (ll i=n/2-num/2+1;i<n/2+num/2;i++){
            help+=b[i][n/2+num/2-1]+'0';
        }
        for (ll i=n/2+num/2-2;i>=n/2-num/2;i--){
            help+=b[n/2+num/2-1][i]+'0';
        }
        for (ll i=n/2+num/2-2;i>n/2-num/2;i--){
            help+=b[i][n/2-num/2]+'0';
        }
        s+=help;
        s+=help;
        vector<int> prefix=zfunct(s);
        flag=false;
        for (int i=0;i<prefix.size();i++){
            if (prefix[i]==help.size()) {
                flag = true;
                break;
            }
        }
        if (!flag)
            break;
    }
    if (!flag)
        cout << "NO" << endl;
    else
        cout << "YES" << endl;
}

int main() {
    int t;
    //cin >> t;
    t=1;
    while (t--) {
        solved();
    }
    return 0;
}