#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
	int n, shark, home;
	cin >> n;
	vector <int> x(n);
	for (int i = 0; i < n; i++)
		cin >> x[i];
	cin >> shark >> home;

	int steps = abs(shark - home);

	vector <int> dist(n);
	for (int i = 0; i < n; i++)
		dist[i] = abs(home - x[i]);
	sort(dist.begin(), dist.end());

	int res = 0;
	for (int i = 0; i < n || steps > 0; i++) {
		steps -= dist[i];
		if (steps > 0)
			res++;
	}

	cout << res;

	return 0;
}