#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <bitset>

#define ln '\n'
#define ll long long
#define ioio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define X first
#define Y second

const double pi = acos(-1.0);
const double eps = 1e-9;
const int INF = 1e9;

using namespace std;

vector<int> prefix(string s) {
	int n = s.size();
	vector<int> p(n);
	for (int i = 1; i < n; ++i) {
		int j = p[i - 1];
		while (j > 0 && s[i] != s[j])
			j = p[j - 1];
		if (s[i] == s[j])  ++j;
		p[i] = j;
	}
	return p;
}


void solve()
{



	// Nickir, esli ti eto vidish - plamennii privet, zadacha pro oldov - polnaya jiza




	int n;
	cin >> n;
	vector<vector<int>>nov(n, vector<int>(n));
	vector<vector<int>>old(n, vector<int>(n));

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> old[i][j];
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> nov[i][j];

	vector<string>cells_a, cells_b;

	for (int k = 0; k < n / 2; ++k)
	{
		string str;
		for (int i = k; i < n - k; ++i)
			str += to_string(old[k][i]);



		for (int i = k + 1; i < n - k; ++i)
			str += to_string(old[i][n - k - 1]);


		for (int i = n - k - 2; i >= k; --i)
			str += to_string(old[n - k - 1][i]);


		for (int i = n - k - 2; i > k; --i)
			str += to_string(old[i][k]);
		
		str += str;
		cells_a.push_back(str);
	}
	for (int k = 0; k < n / 2; ++k)
	{
		string str;
		for (int i = k; i < n - k; ++i)
			str += to_string(nov[k][i]);



		for (int i = k + 1; i < n - k; ++i)
			str += to_string(nov[i][n - k - 1]);


		for (int i = n - k - 2; i >= k; --i)
			str += to_string(nov[n - k - 1][i]);


		for (int i = n - k - 2; i > k; --i)
			str += to_string(nov[i][k]);

		cells_b.push_back(str);
	}
	int ans = 0;
	for (int i = 0; i < n / 2; ++i)
	{
		vector<int>p = prefix(cells_b[i] + "#" + cells_a[i]);
		for (int j = cells_b[i].size(); j < p.size(); ++j)
		{
			if (p[j] == cells_b[i].size())
			{
				ans++;
				break;
			}

		}
	}
	cout << (ans == n / 2 ? "YES" : "NO");
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ioio;
	cout << fixed << setprecision(15);
	int n = 1;
	//cin >> n;
	for (int i = 0; i < n; ++i) {
		//cout << ln << "TEST NUMBER" << i + 1 << ln << ln;
		solve();
	}
}