#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
	int n;
	cin >> n;
	
	vector<int> ans;
	for (int i = 0; i < 10000; ++i) {
		int num = i;
		ll res = num;
		bool f = true;
		for (; num > 0; num /= 10) {
			f &= (num % 10 != 1);
			res *= num % 10;
		}
		
		if (res == n && f)
			ans.push_back(i);
	}
	
	if (ans.size() == 1)
		cout << ans[0] << endl;
	else
		cout << "ERROR" << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}