#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

const int MAXN = 100001;
int n, t[4 * MAXN];
void build(vector<int> a, int v, int tl, int tr) {
	if (tl == tr)
		t[v] = a[tl];
	else {
		int tm = (tl + tr) / 2;
		build(a, v * 2, tl, tm);
		build(a, v * 2 + 1, tm + 1, tr);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}
int sum(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return 0;
	if (l == tl && r == tr)
		return t[v];
	int tm = (tl + tr) / 2;
	return sum(v * 2, tl, tm, l, min(r, tm))
		+ sum(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}
void update(int v, int tl, int tr, int pos, int new_val) {
	if (tl == tr)
		t[v] = new_val;
	else {
		int tm = (tl + tr) / 2;
		if (pos <= tm)
			update(v * 2, tl, tm, pos, new_val);
		else
			update(v * 2 + 1, tm + 1, tr, pos, new_val);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}


}

vector<int> card;
string mag;


int main()
{
	/*int n;
	vector<int> calmar;
	int shark;
	int safeHouse;

	cin >> n;
	for (int i = 0; i < n; i++)
	{

	}*/

	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int tmp;
		cin >> tmp;
		card.push_back(tmp);
		
	}
	cin >> mag;
	build(card,1,0,n-1);
	for (int i = 0; i < mag.length(); i++)
	{
		if (mag[i] == '0')
		{
			for (int i = 0; i < n; i++)
			{
				if (card[i] % 2 == 0)
					card[i] /= 2;
				update(1, 0, n - 1, i, card[i]);
			}
			cout <<sum(1, 0, n - 1, 0, n - 1) << endl;
		}
		else if (mag[i] == '1')
		{
			for (int i = 0; i < n; i++)
			{
				if (card[i] % 2 != 0)
					card[i]--;
				update(1, 0, n - 1, i, card[i]);
			}
			cout << sum(1, 0, n - 1, 0, n - 1) << endl;
		}
	}
	return 0;
}