#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;

ll func(int n){
    return (n * (2 + (n - 1))) / 2;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m, d;
    cin >> n;
    vector<vector<int>> g(n, vector<int>());

    for (int i = 0; i < n-1; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }

    ll ans = 0;

    for(int i = 0; i < n; i++){
        ans += func(g[i].size()-1);
    }

    int maxFirst = 0, maxIterateFirst = -1;
    for(int i = 0; i < n; i++){
        if(g[i].size() > maxFirst){
            maxFirst = g[i].size();
            maxIterateFirst = i;
        }
    }

    int maxSecond = 0, maxIterateSecond = -1;
    for(int i = 0; i < n; i++){
        if(i == maxIterateFirst) continue;
        if(g[i].size() > maxSecond){
            maxSecond = g[i].size();
            maxIterateSecond = i;
        }
    }

    int maxThird = 0, maxIterateThird = -1;
    for(int i = 0; i < n; i++){
        if(i == maxIterateSecond || i == maxIterateFirst) continue;
        if(g[i].size() > maxThird){
            maxThird = g[i].size();
            maxIterateThird = i;
        }
    }

    bool flag1 = true, flag2 = true;
    vector<int> whatInMax(n, 0);

    for(int i = 0; i < g[maxIterateFirst].size(); i++){
        whatInMax[g[maxIterateFirst][i]] = 1;
        if(g[maxIterateFirst][i] == maxIterateSecond){
            flag1 = false;
        }
        if(g[maxIterateFirst][i] == maxIterateThird){
            flag2 = false;
        }
    }

    if(flag1 || flag2){
        if(flag1){
            cout << ans + maxFirst + maxSecond << endl;
            cout << maxIterateFirst+1 << " " << maxIterateSecond+1;
        } else if (flag2){
            cout << ans + maxFirst + maxThird << endl;
            cout << maxIterateFirst+1 << " " << maxIterateThird+1;
        }
    } else {
        int max = 0, maxi = 0;
        for(int i = 0; i < n; i++){
            if(whatInMax[i] == 0 && g[i].size() > max){
                max = g[i].size();
                maxi = i;
            }
        }
        if(maxFirst + max > maxSecond + maxThird){
            cout << ans + maxFirst + max << endl;
            cout << maxIterateFirst+1 << " " << maxi+1;
        } else {
            cout << ans + maxSecond + maxThird << endl;
            cout << maxIterateThird+1 << " " << maxIterateSecond+1;
        }
    };



    return 0;
}