#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long

using namespace std;


void runn(ll time) {
    cout << "run " << time << endl;
    fflush(stdout);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll count = 0;
    ll run = 0;
    ll max = 100;
    ll min = 0;

    runn(max);

    run += max;
    cin >> count;
    min = run / (count + 1) + 1;
    max = run / count;

    while (min < max - 1) {
        ll avr = (max - min) / 2;
        avr += min;
        runn(avr);
        run += avr;

        //считываем круги
        cin >> count;

        //считаем новые диапазоны
        ll newMin = run / (count + 1) + 1;
        ll newMax = run / count;

        if(newMin > min){
            min = newMin;
        }

        if(newMax < max){
            max = newMax;
        }
    }

    ll backCount = count;
    runn(run-(min*(count)));

    cin >> count;

    if(count == backCount){
        cout << "ensuare " << max << endl;
    } else {
        cout << "ensuare " << min << endl;
    }
    return 0;
}