#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>

#define ll long long
#define  ld long double
#define INF 10e+9
using namespace std;



int main()
{
    cin.tie(nullptr);
    std::istream::sync_with_stdio(false);

    ll n, y, z;
    cin >> n;
    vector<ll> x(n, 0);
    for (ll& v : x)
    {
        cin >> v;
    }
    cin >> y >> z;
    priority_queue<ll, vector<ll>, greater<>> q;
    for (ll& v : x)
    {
        q.push(abs(v - z));
    }

    ll out = 0;
    while (true)
    {
        if (q.empty())
            break;

        ll v = q.top();
        q.pop();

        if (v >= abs(z - y))
            break;
        else
        {
            ++out;
            if (y > z)
            {
                y -= min(v, abs(z - y));
            }
            else
            {
                y += min(v, abs(z - y));
            }
        }
    }
    cout << out;

    return 0;
}