#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;
int n;

unordered_set<long long> v[300000];
vector<pair<long long, long long> > puk;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;

    for (int i = 0; i < n; i++) {
        long long x, y;
        cin >> x >> y;
        v[x].insert(y);
        v[y].insert(x);
    }
    long long all_sum = 0;
    for (int i = 1; i <= n; i++) {
        puk.push_back({v[i].size(), i});
        all_sum += (v[i].size() * (v[i].size() - 1)) / 2;
    }

    sort(puk.begin(), puk.end());

    long long ans = -1;

    long long ans_u, ans_v;

    for (int i = puk.size() - 1; i > 0; i--) {
        for (int j = i - 1; j >= 0; j--) {
            if (!v[puk[i].second].count(puk[j].second)) {
                if (puk[i].first + puk[j].first > ans) {
                    ans = max(ans, puk[i].first + puk[j].first);
                    ans_u = puk[i].second;
                    ans_v = puk[j].second;
                }
                break;
            }
        }
    }

    cout << all_sum + ans << endl << ans_u << " " << ans_v;
}