#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<int> v;
string s;
int to[100005];
int sub[100005];

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n;
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        ans += x;
        v.push_back(x);
    }
    cin >> s;
    int m = s.length();

    for(int i = 0; i < m; i++) {
        to[i] = -1;
        if (s[i] == '1') {
            for (int j = i - 1; j >= 0; j--) {
                if (s[j] == '1') {
                    break;
                }
                to[j] = i;
            }
        }
        if (s[i] == '0') {
            for (int j = i - 1; j >= 0; j--) {
                if (s[j] == '0') {
                    break;
                }
                to[j] = i;
            }
        }
    }

    for(int i = 0; i < n; i++) {
        int x = v[i];
        int j = 0;
        while((j != -1) && (j < m)) {
            if (s[j] == '0') {
                if (x % 2 == 0) {
                    sub[j] += x / 2;
                    x /= 2;
                    j++;
                } else {
                    j = to[j];
                }
            } else {
                if (x % 2 == 1) {
                    sub[j] += 1;
                    x -= 1;
                    j++;
                } else {
                    j = to[j];
                }
            }
        }
    }
    for(int i = 0; i < m; i++) {
        cout << ans - sub[i] << endl;
        ans -= sub[i];
    }
}