#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
int a[205][205];
int b[205][205];
vector<int> va[105];
vector<int> vb[105];

vector<int> prefix_function (vector<int> s) {
    int n = (int) s.size();
    vector<int> pi (n);
    for (int i=1; i<n; ++i) {
        int j = pi[i-1];
        while (j > 0 && s[i] != s[j])
            j = pi[j-1];
        if (s[i] == s[j])  ++j;
        pi[i] = j;
    }
    return pi;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, i, j, k;
    cin >> n;
    for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++) {
            cin >> b[i][j];
        }
    }
    int m = n / 2;

    for (k = 0; k < m; k++) {
        i = k;
        j = k;
        for (; j < n - 1 - k; j++) {
            va[k].push_back(a[i][j]);
        }
        for (; i < n - 1 - k; i++) {
            va[k].push_back(a[i][j]);
        }
        for (; j > k; j--) {
            va[k].push_back(a[i][j]);
        }
        for (; i > k; i--) {
            va[k].push_back(a[i][j]);
        }
    }

    for (k = 0; k < m; k++) {
        i = k;
        j = k;
        for (; j < n - 1 - k; j++) {
            vb[k].push_back(b[i][j]);
        }
        for (; i < n - 1 - k; i++) {
            vb[k].push_back(b[i][j]);
        }
        for (; j > k; j--) {
            vb[k].push_back(b[i][j]);
        }
        for (; i > k; i--) {
            vb[k].push_back(b[i][j]);
        }
    }

    for (k = 0; k < m; k++) {
        auto v1 = va[k];
        int puk = v1.size();

        v1.push_back(1000000005);
        v1.insert(v1.end(), vb[k].begin(), vb[k].end());
        v1.insert(v1.end(), vb[k].begin(), vb[k].end());

        auto p = prefix_function(v1);
        bool q = false;
        for(int x: p) {
            if (x == puk) {
                q = true;
            }
        }
        if (!q) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES";
    return 0;
}
