#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <algorithm>
#include <climits>
#include <utility>
#include <cmath>
#include <set>

typedef long long int lli;
typedef unsigned long long int ull;
typedef long double ld;
using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	lli n;
	cin >> n;

	vector <vector <lli>> a(n, vector <lli>(n));
	for (lli i = 0; i < n; i++)
		for (lli j = 0; j < n; j++)
			cin >> a[i][j];

	vector <vector <lli>> b(n, vector <lli>(n));
	for (lli i = 0; i < n; i++)
		for (lli j = 0; j < n; j++)
			cin >> b[i][j];

	vector <vector <lli>> ha(n / 2, vector <lli>(0));
	for (lli i = 0; i < n / 2; i++)
	{
		for (lli j = i; j < n - i; j++)
			ha[i].push_back(a[i][j]);
		for (lli j = i + 1; j < n - i; j++)
			ha[i].push_back(a[j][n - 1 - i]);
		for (lli j = i + 1; j < n - i; j++)
			ha[i].push_back(a[n - 1 - i][n - 1 - j]);
		for (lli j = i + 1; j < n - 1 - i; j++)
			ha[i].push_back(a[n - 1 - j][i]);
	}

	vector <vector <lli>> hb(n / 2, vector <lli>(0));
	for (lli i = 0; i < n / 2; i++)
	{
		for (lli j = i; j < n - i; j++)
			hb[i].push_back(b[i][j]);
		for (lli j = i + 1; j < n - i; j++)
			hb[i].push_back(b[j][n - 1 - i]);
		for (lli j = i + 1; j < n - i; j++)
			hb[i].push_back(b[n - 1 - i][n - 1 - j]);
		for (lli j = i + 1; j < n - 1 - i; j++)
			hb[i].push_back(b[n - 1 - j][i]);
	}

	for (lli i = 0; i < n / 2; i++) {
		lli ms = ha[i].size() - 1, cs = 0, ts = ha[i].size();
		while (true)
		{
			bool flag = true;
			for (lli j = 0; j < ts - 1; j++)
			{
				if (ha[i][j] != hb[i][(j + cs) % ts])
				{
					flag = false;
					break;
				}
			}

			if (flag) break;
			else
			{
				cs++;
				if (cs > ms)
				{
					cout << "NO";
					return 0;
				}
			}
		}
	}

	cout << "YES";
}