    // красивая история жаль что аниме
    
    #include <bits/stdc++.h>

    #define ll      long long
    #define ld      long double
    #define sz(v)   (int)(v.size())
    #define inf     (ll)(1e17)
    #define mod     (ll)(3)

    using namespace std;

    vector< ll > tree_max, tree_sum;
    vector< ll > a;

    void build_max(int v, int l, int r) {
        if (l == r) {
            tree_max[v] = l;
            return;
        }

        int mid = (l + r) / 2;

        build_max(v * 2, l, mid);
        build_max(v * 2 + 1, mid + 1, r);

        if (a[ tree_max[v * 2] ] >= a[ tree_max[v * 2 + 1] ]) {
            tree_max[v] = tree_max[v * 2];
        }
        else {
            tree_max[v] = tree_max[v * 2 + 1];
        }
        
    }
    int get_max(int v, int tl, int tr, int l, int r) {

        if (tl == l && tr == r) {
            return tree_max[v];
        }

        int pos1 = -1, pos2 = -1;
        int mid = (tl + tr) / 2;

        if (l <= mid) {
            pos1 = get_max(v * 2, tl, mid, l, min(mid, r));
        }
        if (r > mid) {
            pos2 = get_max(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r);
        }

        if (pos1 == -1) return pos2;
        if (pos2 == -1) return pos1;

        if (a[pos1] >= a[pos2]) return pos1;
        else return pos2;

    }

    void update_max(int v, int l, int r, int pos) {
        if (l == r) {
            a[pos] = -1;
            return;
        }

        int mid = (l + r) / 2;
        
        if (pos <= mid) {
            update_max(v * 2, l, mid, pos);
        }
        else {
            update_max(v * 2 + 1, mid + 1, r, pos);
        }

        if (a[ tree_max[v * 2] ] >= a[ tree_max[v * 2 + 1] ]) {
            tree_max[v] = tree_max[v * 2];
        }
        else {
            tree_max[v] = tree_max[v * 2 + 1];
        }
    }

    int get_sum(int v, int tl, int tr, int l, int r) {

        if (tl == l && tr == r) {
            return tree_sum[v];
        }

        int s1 = 0, s2 = 0;
        int mid = (tl + tr) / 2;

        if (l <= mid) {
            s1 = get_sum(v * 2, tl, mid, l, min(mid, r));
        }
        if (r > mid) {
            s2 = get_sum(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r);
        }

        return s1 + s2;

    }

    void update_sum(int v, int l, int r, int pos) {

        if (l == r) {
            tree_sum[v] = 1;
            return;
        }

        int mid = (l + r) / 2;

        if (pos <= mid) {
            update_sum(v * 2, l, mid, pos);
        }
        else {
            update_sum(v * 2 + 1, mid + 1, r, pos);
        }

        tree_sum[v] = tree_sum[v * 2] + tree_sum[v * 2 + 1];

    }

    int main() {
        ios_base::sync_with_stdio(0);
        cin.tie(0); cout.tie(0);   

        #ifndef ONLINE_JUDGE
            ifstream cin("input.txt");
            ofstream cout("output.txt");
        #endif
        
        ll n;
        cin >> n;
        a.resize(n);

        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        vector<ll> mx = a;
        sort( mx.rbegin(), mx.rend() );

        int mx_id = 0;

        tree_max.resize(4 * n);
        tree_sum.resize(4 * n);

        build_max(1, 0, n - 1);

        ll res = 0;
        int cur_max, prev_max = -1;

        for (int i = 0; i < n; i++) {

            cur_max = get_max(1, 0, n - 1, max(0, prev_max), n - 1);

            if (a[cur_max] != mx[ mx_id ]) {
                cur_max = get_max(1, 0, n - 1, 0, n - 1);
            }

            mx_id++;
            
            if (a[cur_max] == -1) break;

            

            if (cur_max > prev_max) {
                res += cur_max - prev_max - 1;
                res -= (prev_max + 1 == cur_max ? 0 : ( get_sum(1, 0, n - 1, prev_max + 1, cur_max - 1)  ));
            }
            else {
                res += n - prev_max - 1 + cur_max;
                res -= ( (cur_max == 0 ? 0 : get_sum(1, 0, n - 1, 0, cur_max - 1)) + ( prev_max == n - 1 ? 0 : get_sum(1, 0, n - 1, prev_max + 1, n - 1) ) );
            }

            update_max(1, 0, n - 1, cur_max);
            update_sum(1, 0, n - 1, cur_max);


            prev_max = cur_max;

            

        }

        cout << res;        
        

        

        return 0;
    }