def prime_factors(n):
    res = []
    d = 2
    while d * d <= n:
        if n % d == 0:
            res.append(d)
            n //= d
        else:
            d += 1
    if n > 1:
        res.append(n)
    return res


def all_multi(nums):
    res = set()
    for i in range(len(nums)):
        for j in range(len(nums)):
            res.add(nums[i]*nums[j])
            if nums[i] > 9:
                res.add(nums[i])
            if nums[j] > 9:
                res.add(nums[j])

    return res


def mul(num):
    res = num
    for c in str(num):
        res *= int(c)
    return res


n = int(input())
factors = prime_factors(n)

res = []
for num in all_multi(factors):
    if n == mul(num):
        res.append(num)

if len(res) == 1:
    print(res[0])
else:
    print("ERROR")
